# Class VulkanFormatProperties.Builder

java.lang.Object
com.io7m.jcoronado.api.VulkanFormatProperties.Builder

Enclosing class:
  `VulkanFormatProperties`

public static final class VulkanFormatProperties.Builder extends Object
Builds instances of type `VulkanFormatProperties`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final VulkanFormatProperties.Builder`
  `addAllBufferFeatures(Iterable<VulkanFormatFeatureFlag> elements)`
  Adds elements to `bufferFeatures` set.
  `final VulkanFormatProperties.Builder`
  `addAllLinearTilingFeatures(Iterable<VulkanFormatFeatureFlag> elements)`
  Adds elements to `linearTilingFeatures` set.
  `final VulkanFormatProperties.Builder`
  `addAllOptimalTilingFeatures(Iterable<VulkanFormatFeatureFlag> elements)`
  Adds elements to `optimalTilingFeatures` set.
  `final VulkanFormatProperties.Builder`
  `addBufferFeatures(VulkanFormatFeatureFlag element)`
  Adds one element to `bufferFeatures` set.
  `final VulkanFormatProperties.Builder`
  `addBufferFeatures(VulkanFormatFeatureFlag... elements)`
  Adds elements to `bufferFeatures` set.
  `final VulkanFormatProperties.Builder`
  `addLinearTilingFeatures(VulkanFormatFeatureFlag element)`
  Adds one element to `linearTilingFeatures` set.
  `final VulkanFormatProperties.Builder`
  `addLinearTilingFeatures(VulkanFormatFeatureFlag... elements)`
  Adds elements to `linearTilingFeatures` set.
  `final VulkanFormatProperties.Builder`
  `addOptimalTilingFeatures(VulkanFormatFeatureFlag element)`
  Adds one element to `optimalTilingFeatures` set.
  `final VulkanFormatProperties.Builder`
  `addOptimalTilingFeatures(VulkanFormatFeatureFlag... elements)`
  Adds elements to `optimalTilingFeatures` set.
  `VulkanFormatProperties`
  `build()`
  Builds a new `VulkanFormatProperties`.
  `final VulkanFormatProperties.Builder`
  `from(VulkanFormatPropertiesType instance)`
  Fill a builder with attribute values from the provided `VulkanFormatPropertiesType` instance.
  `final VulkanFormatProperties.Builder`
  `setBufferFeatures(Iterable<VulkanFormatFeatureFlag> elements)`
  Sets or replaces all elements for `bufferFeatures` set.
  `final VulkanFormatProperties.Builder`
  `setLinearTilingFeatures(Iterable<VulkanFormatFeatureFlag> elements)`
  Sets or replaces all elements for `linearTilingFeatures` set.
  `final VulkanFormatProperties.Builder`
  `setOptimalTilingFeatures(Iterable<VulkanFormatFeatureFlag> elements)`
  Sets or replaces all elements for `optimalTilingFeatures` set.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final VulkanFormatProperties.Builder from(VulkanFormatPropertiesType instance)
    Fill a builder with attribute values from the provided `VulkanFormatPropertiesType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values. Collection elements and entries will be added, not replaced.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### addLinearTilingFeatures

    public final VulkanFormatProperties.Builder addLinearTilingFeatures(VulkanFormatFeatureFlag element)
    Adds one element to `linearTilingFeatures` set.
    Parameters:
      `element` - A linearTilingFeatures element
    Returns:
      `this` builder for use in a chained invocation

  - ### addLinearTilingFeatures

    public final VulkanFormatProperties.Builder addLinearTilingFeatures(VulkanFormatFeatureFlag... elements)
    Adds elements to `linearTilingFeatures` set.
    Parameters:
      `elements` - An array of linearTilingFeatures elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setLinearTilingFeatures

    public final VulkanFormatProperties.Builder setLinearTilingFeatures(Iterable<VulkanFormatFeatureFlag> elements)
    Sets or replaces all elements for `linearTilingFeatures` set.
    Parameters:
      `elements` - An iterable of linearTilingFeatures elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addAllLinearTilingFeatures

    public final VulkanFormatProperties.Builder addAllLinearTilingFeatures(Iterable<VulkanFormatFeatureFlag> elements)
    Adds elements to `linearTilingFeatures` set.
    Parameters:
      `elements` - An iterable of linearTilingFeatures elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addOptimalTilingFeatures

    public final VulkanFormatProperties.Builder addOptimalTilingFeatures(VulkanFormatFeatureFlag element)
    Adds one element to `optimalTilingFeatures` set.
    Parameters:
      `element` - A optimalTilingFeatures element
    Returns:
      `this` builder for use in a chained invocation

  - ### addOptimalTilingFeatures

    public final VulkanFormatProperties.Builder addOptimalTilingFeatures(VulkanFormatFeatureFlag... elements)
    Adds elements to `optimalTilingFeatures` set.
    Parameters:
      `elements` - An array of optimalTilingFeatures elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setOptimalTilingFeatures

    public final VulkanFormatProperties.Builder setOptimalTilingFeatures(Iterable<VulkanFormatFeatureFlag> elements)
    Sets or replaces all elements for `optimalTilingFeatures` set.
    Parameters:
      `elements` - An iterable of optimalTilingFeatures elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addAllOptimalTilingFeatures

    public final VulkanFormatProperties.Builder addAllOptimalTilingFeatures(Iterable<VulkanFormatFeatureFlag> elements)
    Adds elements to `optimalTilingFeatures` set.
    Parameters:
      `elements` - An iterable of optimalTilingFeatures elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addBufferFeatures

    public final VulkanFormatProperties.Builder addBufferFeatures(VulkanFormatFeatureFlag element)
    Adds one element to `bufferFeatures` set.
    Parameters:
      `element` - A bufferFeatures element
    Returns:
      `this` builder for use in a chained invocation

  - ### addBufferFeatures

    public final VulkanFormatProperties.Builder addBufferFeatures(VulkanFormatFeatureFlag... elements)
    Adds elements to `bufferFeatures` set.
    Parameters:
      `elements` - An array of bufferFeatures elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setBufferFeatures

    public final VulkanFormatProperties.Builder setBufferFeatures(Iterable<VulkanFormatFeatureFlag> elements)
    Sets or replaces all elements for `bufferFeatures` set.
    Parameters:
      `elements` - An iterable of bufferFeatures elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addAllBufferFeatures

    public final VulkanFormatProperties.Builder addAllBufferFeatures(Iterable<VulkanFormatFeatureFlag> elements)
    Adds elements to `bufferFeatures` set.
    Parameters:
      `elements` - An iterable of bufferFeatures elements
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public VulkanFormatProperties build()
    Builds a new `VulkanFormatProperties`.
    Returns:
      An immutable instance of VulkanFormatProperties
    Throws:
      `IllegalStateException` - if any required attributes are missing